import { TwingExtensionInterface } from "./extension-interface";
import { TwingTokenParserInterface } from "./token-parser-interface";
import { TwingNodeVisitorInterface } from "./node-visitor-interface";
import { TwingFilter } from "./filter";
import { TwingFunction } from "./function";
import { TwingTest } from "./test";
export declare type TwingOperator = {
    precedence: number;
    associativity?: string;
    factory: Function;
    callable?: Function;
};
export declare class TwingExtension implements TwingExtensionInterface {
    TwingExtensionInterfaceImpl: TwingExtensionInterface;
    constructor();
    getTokenParsers(): Array<TwingTokenParserInterface>;
    getNodeVisitors(): TwingNodeVisitorInterface[];
    getFilters(): Map<string | number, TwingFilter>;
    getTests(): Array<TwingTest>;
    getFunctions(): Map<string | number, TwingFunction>;
    getOperators(): [Map<string, TwingOperator>, Map<string, TwingOperator>];
}
