"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const extension_1 = require("../extension");
const function_1 = require("../function");
const var_dump_1 = require("../helper/var-dump");
class TwingExtensionDebug extends extension_1.TwingExtension {
    getFunctions() {
        return new Map([
            [0, new function_1.TwingFunction('dump', twingVarDump, {
                    is_safe: ['html'],
                    needs_context: true,
                    needs_environment: true
                })],
        ]);
    }
}
exports.TwingExtensionDebug = TwingExtensionDebug;
function twingVarDump(env, context, ...vars) {
    let parts = [];
    if (!env.isDebug()) {
        return null;
    }
    if (vars.length < 1) {
        // dump the whole context
        return var_dump_1.varDump(context);
    }
    for (let var_ of vars) {
        parts.push(var_dump_1.varDump(var_));
    }
    parts.push('');
    return parts.join('\n');
}
exports.twingVarDump = twingVarDump;
