import { TwingExtension } from "../extension";
import { TwingNodeVisitorEscaper } from "../node-visitor/escaper";
import { TwingTokenParserAutoEscape } from "../token-parser/auto-escape";
import { TwingFilter } from "../filter";
export declare class TwingExtensionEscaper extends TwingExtension {
    private defaultStrategy;
    /**
     * @param {string} defaultStrategy An escaping strategy
     */
    constructor(defaultStrategy?: string | boolean | Function);
    getTokenParsers(): TwingTokenParserAutoEscape[];
    getNodeVisitors(): TwingNodeVisitorEscaper[];
    getFilters(): Map<number, TwingFilter>;
    /**
     * Sets the default strategy to use when not defined by the user.
     *
     * The strategy can be a valid PHP callback that takes the template
     * name as an argument and returns the strategy to use.
     *
     * @param {string|boolean|Function} defaultStrategy An escaping strategy
     */
    setDefaultStrategy(defaultStrategy: string | boolean | Function): void;
    /**
     * Gets the default strategy to use when not defined by the user.
     *
     * @param {string|boolean} name The template name
     *
     * @returns {string|false} The default strategy to use for the template
     */
    getDefaultStrategy(name: string | boolean): string;
}
/**
 * Marks a variable as being safe.
 *
 * @param {string} string A variable
 *
 * @return string
 */
export declare function twingRawFilter(string: string): string;
