import { TwingNode } from "./node";
export declare type TwingFilterOptions = {
    needs_environment?: boolean;
    needs_context?: boolean;
    is_variadic?: boolean;
    is_safe?: Array<any>;
    is_safe_callback?: Function;
    pre_escape?: string;
    preserves_safety?: Array<string>;
    expression_factory?: Function;
    deprecated?: string;
    alternative?: TwingFilter;
};
export declare class TwingFilter {
    private name;
    private callable;
    private options;
    private methodArguments;
    constructor(name: string, callable: Function, options?: TwingFilterOptions);
    getName(): string;
    /**
     * Returns the callable to execute for this filter.
     *
     * @returns {Function}
     */
    getCallable(): Function;
    /**
     *
     * @returns {Function}
     */
    getExpressionFactory(): Function;
    setArguments(someArguments: Array<any>): void;
    getArguments(): any[];
    needsEnvironment(): boolean;
    needsContext(): boolean;
    /**
     *
     * @param {TwingNode} filterArgs
     * @returns boolean
     */
    getSafe(filterArgs: TwingNode): any;
    getPreservesSafety(): string[];
    getPreEscape(): string;
    isVariadic(): boolean;
    isDeprecated(): string;
    /**
     *
     * @returns {string}
     */
    getDeprecatedVersion(): string;
    /**
     *
     * @returns {TwingFilter}
     */
    getAlternative(): TwingFilter;
}
