import { TwingLoaderInterface } from "../loader-interface";
import { TwingSource } from "../source";
/**
 * Loads templates from other loaders.
 *
 * @author Eric MORAND <eric.morand@gmail.com>
 */
export declare class TwingLoaderChain implements TwingLoaderInterface {
    TwingLoaderInterfaceImpl: TwingLoaderInterface;
    private hasSourceCache;
    private loaders;
    /**
     * @param {Array<TwingLoaderInterface>} loaders
     */
    constructor(loaders?: Array<TwingLoaderInterface>);
    addLoader(loader: TwingLoaderInterface): void;
    getSourceContext(name: string): TwingSource;
    exists(name: string): boolean;
    getCacheKey(name: string): string;
    isFresh(name: string, time: number): boolean;
    resolve(name: string): string;
}
