import { TwingNode } from "../node";
import { TwingSource } from "../source";
import { TwingCompiler } from "../compiler";
/**
 * Represents a module node.
 */
export declare class TwingNodeModule extends TwingNode {
    source: TwingSource;
    constructor(body: TwingNode, parent: TwingNode, blocks: TwingNode, macros: TwingNode, traits: TwingNode, embeddedTemplates: Array<{}>, source: TwingSource);
    setIndex(index: number): void;
    compile(compiler: TwingCompiler): void;
    protected compileTemplate(compiler: TwingCompiler): void;
    protected compileGetParent(compiler: TwingCompiler): void;
    protected compileClassHeader(compiler: TwingCompiler): void;
    protected compileConstructor(compiler: TwingCompiler): void;
    protected compileMacros(compiler: TwingCompiler): void;
    protected compileDisplay(compiler: TwingCompiler): void;
    protected compileGetTemplateName(compiler: TwingCompiler): void;
    protected compileGetSourceMapSource(compiler: TwingCompiler): void;
    protected compileIsTraitable(compiler: TwingCompiler): void;
    protected compileDebugInfo(compiler: TwingCompiler): void;
    protected compileGetSourceContext(compiler: TwingCompiler): void;
    protected compileClassfooter(compiler: TwingCompiler): void;
}
