export declare class TwingProfilerProfile {
    static ROOT: string;
    static BLOCK: string;
    static TEMPLATE: string;
    static MACRO: string;
    private template;
    private name;
    private type;
    private starts;
    private ends;
    private profiles;
    [Symbol.iterator]: () => IterableIterator<TwingProfilerProfile>;
    constructor(template?: string, type?: string, name?: string);
    static unserialize(data: string): TwingProfilerProfile;
    getTemplate(): string;
    getType(): string;
    getName(): string;
    isRoot(): boolean;
    isTemplate(): boolean;
    isBlock(): boolean;
    isMacro(): boolean;
    getProfiles(): TwingProfilerProfile[];
    addProfile(profile: TwingProfilerProfile): void;
    /**
     * Returns the duration in microseconds.
     *
     * @return int
     */
    getDuration(): number;
    /**
     * Returns the memory usage in bytes.
     *
     * @return int
     */
    getMemoryUsage(): number;
    /**
     * Returns the peak memory usage in bytes.
     *
     * @return int
     */
    getPeakMemoryUsage(): number;
    /**
     * Starts the profiling.
     */
    enter(): void;
    /**
     * Stops the profiling.
     */
    leave(): void;
    reset(): void;
}
