"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const security_error_1 = require("./security-error");
/**
 * Exception thrown when a not allowed class property is used in a template.
 *
 * @author Eric MORAND <eric.morand@gmail.com>
 */
class TwingSandboxSecurityNotAllowedPropertyError extends security_error_1.TwingSandboxSecurityError {
    constructor(message, className, propertyName, lineno = -1, filename = null, previous = null) {
        super(message, lineno, filename, previous);
        this.className = className;
        this.propertyName = propertyName;
    }
    getClassName() {
        return this.className;
    }
    getPropertyName() {
        return this.propertyName;
    }
}
exports.TwingSandboxSecurityNotAllowedPropertyError = TwingSandboxSecurityNotAllowedPropertyError;
