export declare type TwingTestOptions = {
    is_variadic?: boolean;
    node_factory?: Function;
    deprecated?: string;
    alternative?: TwingTest;
    need_context?: boolean;
};
export declare class TwingTest {
    private name;
    private callable;
    private options;
    /**
     * Creates a template test.
     *
     * @param {string} name Name of this test
     * @param {Function} callable A callable implementing the test. If null, you need to overwrite the "node_class" option to customize compilation.
     * @param {TwingTestOptions} options Options
     */
    constructor(name: string, callable?: Function, options?: TwingTestOptions);
    getName(): string;
    /**
     * Returns the callable to execute for this test.
     *
     * @return {Function}
     */
    getCallable(): Function;
    getNodeFactory(): Function;
    isVariadic(): boolean;
    isDeprecated(): boolean;
    getDeprecatedVersion(): string;
    getAlternative(): TwingTest;
}
