/**
 * Defines a macro.
 *
 * <pre>
 * {% macro input(name, value, type, size) %}
 *    <input type="{{ type|default('text') }}" name="{{ name }}" value="{{ value|e }}" size="{{ size|default(20) }}" />
 * {% endmacro %}
 * </pre>
 */
import { TwingToken } from "../token";
import { TwingTokenParser } from "../token-parser";
import { TwingNode } from "../node";
export declare class TwingTokenParserMacro extends TwingTokenParser {
    parse(token: TwingToken): TwingNode;
    decideBlockEnd(token: TwingToken): boolean;
    getTag(): string;
}
