(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define("dateformatConverter", [], factory);
	else if(typeof exports === 'object')
		exports["dateformatConverter"] = factory();
	else
		root["dateformatConverter"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "convert", function() { return convert; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "loadConfig", function() { return loadConfig; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__patterns_momentjs__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__patterns_momentjs___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0__patterns_momentjs__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__patterns_bootstrap_datetime_picker__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__patterns_bootstrap_datetime_picker___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1__patterns_bootstrap_datetime_picker__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__patterns_jquery_dateFormat__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__patterns_jquery_dateFormat___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2__patterns_jquery_dateFormat__);




var supportedProperties = ['lowerCaseMeridian', // <Post or ante meridiem (lower case)>
'upperCaseMeridian', // <Post or ante meridiem (upper case)>
'secondsSimple', // <Seconds without leading zero>
'secondsLeading', // <Seconds with leading zero>
'minutesSimple', // <Minutes without leading zero>
'minutesLeading', // <Minutes with leading zero>
'hoursSimple24Format', // <Hours in 24h format without leading zero>
'hoursLeading24Format', // <Hours in 24h format with leading zero>
'hoursSimple12Format', // <Hours in 12h format without leading zero>
'hoursLeading12Format', // <Hours in 12h format with leading zero>
'daysSimple', // <Day of month without leading zero>
'daysLeading', // <Day of month with leading zero>
'monthsSimple', // <Month number without leading zero>
'monthsLeading', // <Month number with leading zero>
'monthsSimpleText', // <Short month name>
'monthsFullText', // <Long month name>
'yearsTwoDigits', // <2 digit year>
'yearsFourDigits', // <4 digit year>
'unixTimestamp', // <Unix timestamp>
'timezoneName' // <Offset from UTC>
];

var loadedConfigurations = {};

var validateString = function validateString(value, display) {
	var validateEmpty = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

	if (typeof value !== 'string') {
		throw new TypeError(display + ' is not a string');
	} else if (validateEmpty && value === '') {
		throw new TypeError(display + ' cannot be an empty string');
	}
};

var validateConfig = function validateConfig(config) {
	// 1. Check if the config is a literal object (has to throw error if is object but is null or Array)
	if (Object.prototype.toString.call(config) !== '[object Object]' || config !== Object(config)) {
		throw new TypeError('Configuration is not an object');
	}
	// 2. Check if the object has keys. If empty, then it is not valid
	if (Object.keys(config).length === 0) {
		throw new TypeError('Configuration does not contain any keys');
	}
	// 3. Check if all properties are supported
	for (var prop in config) {
		if (supportedProperties.indexOf(prop) === -1) {
			throw new TypeError('Property "' + prop + '" is not valid in the configuration');
		}
	}
	// 4. Check if all property values are strings
	for (var _prop in config) {
		if (typeof config[_prop] !== 'string') {
			throw new TypeError('Value of property "' + _prop + '" is not a string');
		}
	}
};

var validateRegisteredConfig = function validateRegisteredConfig(configName) {
	if (!(configName in loadedConfigurations)) {
		throw TypeError('Pattern "' + configName + '" is not registered');
	}
};

var sort = function sort(config) {
	var keys = Object.keys(config);
	keys.sort(function (a, b) {
		var length1 = config[a].length;
		var length2 = config[b].length;
		return length1 > length2 ? -1 : length2 > length1 ? 1 : 0;
	});
	return keys;
};

var transform = function transform(stringToTransform, source, target) {
	var keyArr = sort(source);
	var result = '';
	var strIndex = 0;
	while (strIndex < stringToTransform.length) {
		var found = false;
		for (var propIndex = 0; propIndex < keyArr.length; propIndex++) {
			var prop = keyArr[propIndex];

			if (stringToTransform.indexOf(source[prop], strIndex) === strIndex) {
				result += target[prop];
				strIndex += source[prop].length;
				found = true;
				break;
			}
		}
		if (!found) {
			result += stringToTransform.charAt(strIndex);
			strIndex++;
		}
	}

	return result;
};

var loadConfig = function loadConfig(name, configObject) {
	validateString(name, 'Configuration name', true);
	validateConfig(configObject);
	loadedConfigurations[name] = configObject;
};

var convert = function convert(valueToConvert, sourceFormat, destinationFormat) {
	validateString(valueToConvert, 'Value to convert');
	validateString(sourceFormat, 'Source pattern', true);
	validateString(destinationFormat, 'Destination pattern', true);
	validateRegisteredConfig(sourceFormat);
	validateRegisteredConfig(destinationFormat);

	var sourceFormatObject = loadedConfigurations[sourceFormat];
	var destinationFormatObject = loadedConfigurations[destinationFormat];

	for (var prop in sourceFormatObject) {
		if (!(prop in destinationFormatObject)) {
			destinationFormatObject[prop] = sourceFormatObject[prop];
		}
	}
	return transform(valueToConvert, sourceFormatObject, destinationFormatObject);
};

loadConfig('momentjs', __WEBPACK_IMPORTED_MODULE_0__patterns_momentjs___default.a);
loadConfig('bootstrap-datetime-picker', __WEBPACK_IMPORTED_MODULE_1__patterns_bootstrap_datetime_picker___default.a);
loadConfig('jquery-dateFormat', __WEBPACK_IMPORTED_MODULE_2__patterns_jquery_dateFormat___default.a);



/***/ }),
/* 1 */
/***/ (function(module, exports) {

module.exports = {"lowerCaseMeridian":"a","upperCaseMeridian":"A","secondsSimple":"s","secondsLeading":"ss","minutesSimple":"m","minutesLeading":"mm","hoursSimple24Format":"H","hoursLeading24Format":"HH","hoursSimple12Format":"h","hoursLeading12Format":"hh","daysSimple":"D","daysLeading":"DD","monthsSimple":"M","monthsLeading":"MM","monthsSimpleText":"MMM","monthsFullText":"MMMM","yearsTwoDigits":"YY","yearsFourDigits":"YYYY","unixTimestamp":"X","timezoneName":"Z"}

/***/ }),
/* 2 */
/***/ (function(module, exports) {

module.exports = {"lowerCaseMeridian":"p","upperCaseMeridian":"P","secondsSimple":"s","secondsLeading":"ss","minutesSimple":"i","minutesLeading":"ii","hoursSimple24Format":"h","hoursLeading24Format":"hh","hoursSimple12Format":"H","hoursLeading12Format":"HH","daysSimple":"d","daysLeading":"dd","monthsSimple":"m","monthsLeading":"mm","monthsSimpleText":"M","monthsFullText":"MM","yearsTwoDigits":"yy","yearsFourDigits":"yyyy","unixTimestamp":"t","timezoneName":"Z"}

/***/ }),
/* 3 */
/***/ (function(module, exports) {

module.exports = {"lowerCaseMeridian":"p","upperCaseMeridian":"a","secondsSimple":"s","secondsLeading":"ss","minutesSimple":"m","minutesLeading":"mm","hoursSimple24Format":"H","hoursLeading24Format":"HH","hoursSimple12Format":"h","hoursLeading12Format":"hh","daysSimple":"d","daysLeading":"dd","monthsSimple":"M","monthsLeading":"MM","monthsSimpleText":"MMM","monthsFullText":"MMMM","yearsTwoDigits":"yy","yearsFourDigits":"yyyy"}

/***/ })
/******/ ]);
});
//# sourceMappingURL=dateformat-converter.js.map