'use strict';

exports.__esModule = true;
exports.default = attacher;

var _lowlight = require('lowlight');

var _lowlight2 = _interopRequireDefault(_lowlight);

var _unistUtilVisit = require('unist-util-visit');

var _unistUtilVisit2 = _interopRequireDefault(_unistUtilVisit);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function attacher() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        include = _ref.include,
        exclude = _ref.exclude;

    function visitor(node) {
        var lang = node.lang;

        if (!lang || include && !~include.indexOf(lang) || exclude && ~exclude.indexOf(lang)) {
            return;
        }

        var data = node.data;


        if (!data) {
            node.data = data = {};
        }

        try {
            data.hChildren = _lowlight2.default.highlight(lang, node.value).value;
        } catch (err) {
            data.hChildren = _lowlight2.default.highlightAuto(node.value).value;
        }

        data.hProperties = data.hProperties || {};
        data.hProperties.className = ['hljs'].concat(data.hProperties.className || [], ['language-' + lang]);
    }

    return function (ast) {
        return (0, _unistUtilVisit2.default)(ast, 'code', visitor);
    };
}
module.exports = exports['default'];