import { TwingCacheInterface } from "../cache-interface";
/**
 * Implements a cache on the filesystem.
 *
 * @author Andrew Tch <andrew@noop.lv>
 */
export declare class TwingCacheFilesystem implements TwingCacheInterface {
    TwingCacheInterfaceImpl: TwingCacheInterface;
    private directory;
    private options;
    /**
     * @param directory {string} The root cache directory
     * @param options {number} A set of options
     */
    constructor(directory: string, options?: number);
    generateKey(name: string, className: string): any;
    load(key: string): any;
    write(key: string, content: string): void;
    getTimestamp(key: string): any;
}
