import { TwingExtension } from "../extension";
import { TwingSandboxSecurityPolicyInterface } from "../sandbox/security-policy-interface";
import { TwingTokenParserSandbox } from "../token-parser/sandbox";
import { TwingNodeVisitorSandbox } from "../node-visitor/sandbox";
export declare class TwingExtensionSandbox extends TwingExtension {
    private sandboxedGlobally;
    private sandboxed;
    private policy;
    constructor(policy: TwingSandboxSecurityPolicyInterface, sandboxed?: boolean);
    getTokenParsers(): TwingTokenParserSandbox[];
    getNodeVisitors(): TwingNodeVisitorSandbox[];
    enableSandbox(): void;
    disableSandbox(): void;
    isSandboxed(): boolean;
    isSandboxedGlobally(): boolean;
    setSecurityPolicy(policy: TwingSandboxSecurityPolicyInterface): void;
    getSecurityPolicy(): TwingSandboxSecurityPolicyInterface;
    checkSecurity(tags: Array<string>, filters: Array<string>, functions: Array<string>): void;
    checkMethodAllowed(obj: any, method: string): void;
    checkPropertyAllowed(obj: any, method: string): void;
    ensureToStringAllowed(obj: any): any;
}
