import { TwingExtension } from "../extension";
import { TwingFunction } from "../function";
import { TwingEnvironment } from "../environment";
import { TwingTemplate } from "../template";
export declare class TwingExtensionStringLoader extends TwingExtension {
    getFunctions(): Map<number, TwingFunction>;
}
/**
 * Loads a template from a string.
 *
 * <pre>
 * {{ include(template_from_string("Hello {{ name }}")) }}
 * </pre>
 *
 * @param {TwingEnvironment} env A TwingEnvironment instance
 * @param {string} template A template as a string or object implementing toString()
 *
 * @returns TwingTemplate
 */
export declare function twingTemplateFromString(env: TwingEnvironment, template: string): TwingTemplate;
