"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const iterator_to_map_1 = require("./iterator-to-map");
function merge(iterable1, iterable2) {
    let result = new Map();
    let index = 0;
    let map1 = iterator_to_map_1.iteratorToMap(iterable1);
    for (let [key, value] of map1) {
        if (typeof key === 'number') {
            key = index++;
        }
        result.set(key, value);
    }
    let map2 = iterator_to_map_1.iteratorToMap(iterable2);
    for (let [key, value] of map2) {
        if (typeof key === 'number') {
            key = index++;
        }
        result.set(key, value);
    }
    if (Array.isArray(iterable1)) {
        return [...result.values()];
    }
    return result;
}
exports.merge = merge;
