import { TwingSource } from "./source";
import { TwingTokenStream } from "./token-stream";
import { TwingEnvironment } from "./environment";
export declare class TwingLexer {
    static STATE_DATA: number;
    static STATE_BLOCK: number;
    static STATE_VAR: number;
    static STATE_STRING: number;
    static STATE_INTERPOLATION: number;
    static REGEX_NAME: RegExp;
    static REGEX_NUMBER: RegExp;
    static REGEX_STRING: RegExp;
    static REGEX_DQ_STRING_DELIM: RegExp;
    static REGEX_DQ_STRING_PART: RegExp;
    static PUNCTUATION: string;
    private brackets;
    private code;
    private currentVarBlockLine;
    private cursor;
    private end;
    private env;
    private lineno;
    private columnno;
    private options;
    private position;
    private positions;
    private regexes;
    private source;
    private state;
    private states;
    private tokens;
    constructor(env: TwingEnvironment, options?: {});
    tokenize(source: TwingSource): TwingTokenStream;
    private lexData;
    private lexBlock;
    private lexVar;
    private lexExpression;
    private lexRawData;
    private lexComment;
    private lexString;
    private lexInterpolation;
    private handleLeadingLineFeeds;
    private moveCursor;
    private moveCoordinates;
    private getOperatorRegEx;
    private pushToken;
    private pushState;
    /**
     * @return TwingLexerState
     */
    private popState;
}
