/**
 * Loops over each item of a sequence.
 *
 * <pre>
 * <ul>
 *  {% for user in users %}
 *    <li>{{ user.username|e }}</li>
 *  {% endfor %}
 * </ul>
 * </pre>
 */
import { TwingTokenParser } from "../token-parser";
import { TwingNode } from "../node";
import { TwingToken } from "../token";
import { TwingTokenStream } from "../token-stream";
import { TwingNodeFor } from "../node/for";
export declare class TwingTokenParserFor extends TwingTokenParser {
    parse(token: TwingToken): TwingNodeFor;
    decideForFork(token: TwingToken): boolean;
    decideForEnd(token: TwingToken): boolean;
    checkLoopUsageCondition(stream: TwingTokenStream, node: TwingNode): void;
    getTag(): string;
    private checkLoopUsageBody;
}
